Movie/Movie/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings 
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls, name="adminpanel"),

    path('', include('recommendation.urls')),
    path('', include('home.urls')),
    path('', include('login_signup.urls')),
    path('', include('movie_admin.urls')),
    path('', include('client.urls')),


]




urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)            # django ma media files i.e images lai chinauna ko lagi
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

Movie/home/urls.py
from django.urls import path
from . import views
from django.views.decorators.csrf import csrf_exempt

urlpatterns = [
    path('', csrf_exempt(views.home), name="home"), # yedi ajax call batw hamro view ma aauda csrf token pathaunu chaina vani , csrf_exempt lai import garna parcha.. ani csrf_exempt le hamro view lai surround pani garna parcha
    path('genre/<str:movie_genre>', views.home),
    path('toprating/<str:imdb_rating>', views.home),
    path('year/<int:year>', views.home),
    path('recent/<str:latest>', views.home),



]

Movie/movie_admin/urls.py
from django.urls import path

from . import views

urlpatterns = [

    path('adminhome/', views.adminhome, name="adminhome"),
    path('adminpanel/', views.adminpanel, name="adminpanel"),
    path('view_rating_details/<int:id>', views.rating_details, name="rating_details"),
    path('delete/<int:id>', views.delete, name="delete"),

    path('list_movies/', views.listMovies, name="list_movies"),
    path('add_movies/', views.addMovies, name="add_movies"),
    path('delete_movies/<int:movie_id>', views.deleteMovies, name="delete_movies"),
    path('edit_movies/<int:movie_id>', views.editMovies, name="edit_movies"),

    path('download_csv/', views.dwonloadCSV, name="download_csv")

]

Movie/movie_admin/models.py
from django.db import models

# Create your models here.

Movie/recommendation/models.py
from django.db import models

from login_signup.models import User

from django.core.validators import MaxValueValidator, MinValueValidator


# Create your models here.


class Movie(models.Model):
    GENRE = (  # Choices or dropdown choices
        ('Action', 'Action'),
        ('Animation', 'Animation'),
        ('Comedy', 'Comedy'),
        ('Crime', 'Crime'),
        ('Horror', 'Horror'),
        ('Sci-Fi', 'Sci-Fi'),
        ('War', 'War'),
        ('Action Sci-Fi', 'Action Sci-Fi'),
        ('Comedy Crime', 'Comedy Crime'),
        ('Drama Thriller', 'Drama Thriller'),
    )

    YEAR = (  # Choices or dropdown choices
        (2010, '2010'), (2011, '2011'), (2012, '2012'), (2013, '2013'), (2014, '2014'), (2015, '2015'), (2016, '2016'), (2017, '2017'), (2018, '2018'), (2019, '2019'), (2020, '2020'), (2021, '2021'))

    title = models.CharField(max_length=200)
    genre = models.CharField(max_length=100, choices=GENRE)
    poster = models.FileField()
    imdbrating = models.FloatField(default=1.0)
    year = models.IntegerField(null=True, choices=YEAR)

    def __str__(self):
        return self.title


class Client(models.Model):
    user = models.ForeignKey(User, null=True, blank=True, on_delete=models.CASCADE, related_name='client_user')
    movie = models.ForeignKey(Movie, null=True, blank=True, on_delete=models.CASCADE, related_name="client_movie")
    rating = models.FloatField(default=1, validators=[MaxValueValidator(5), MinValueValidator(0)])

    def __str__(self):
        return self.user.username

Movie/login_signup/forms.py
from django.core.exceptions import ValidationError
from django.forms import ModelForm
from django.contrib.auth.forms import UserCreationForm  # UserCreationForm  import garnu ko karan vaneko yesle djagno ko le User ko lagi diyeko authentication form automatic dinxa... yo form use garyo vani password lai manually hash garnu pardaina... django le automatic hash gardinxa  & Username pahilai nai use vako xa ki nai vanera check garne code lekhnu parena ... django le automatic check gardinxa
from django.contrib.auth.models import User  # yaha User vaneko django le diyeko inbuilt User model ho
from django import forms  # forms.py page ma yo forms vanni import garnai parxa
from django.db import transaction
from .models import *


class CreateClientForm(UserCreationForm):
    class Meta:
        model = User
        fields = ['username', 'email', 'password1', 'password2']
        help_texts = {"username": None,
                      "email": None,
                      "password2": None
                      }

    # views.py bata form.is_valid() method call hunda yo def clean() method run huncha...Yesle  email address unique xa ki xaina validate gareko cha.
    def clean(self):
        email = self.cleaned_data.get('email')
        username = self.cleaned_data.get('username')

        if User.objects.filter(username=username).exists():
            raise ValidationError("Username already exists.")


        if User.objects.filter(email=email).exists():
            raise ValidationError("User having this email already exists.")
        return self.cleaned_data






    @transaction.atomic  # However, if an exception happens in a function decorated with transaction.atomic, then you don't have anything to do, it'll rollback automatically to the savepoint created by the decorator before running the your function, as documented. transaction.atomic  allows us to create a block of code within which the atomicity on the database is guaranteed. If the block of code is successfully completed, the changes are committed to the database. If there is an exception, the changes are rolled back.
    def save(self):
        user = super().save(commit=False)  # yesle form bata database ma value store garni bela ma, user le form ma navareko filed i.e(is_student & is_teacher) both field lai False garauxa i.e( 0 garauxa).
        user.is_client = True  # aba chai table ko is_student vanni field lai balla aba Ture garauxa i.e (1 garauxa)
        user.is_admin = False
        user.save()  # again, save to database
        # Client.objects.create(user=user)      # Student model ko student vanni object create gareko
        return user


class CreateAdminForm(UserCreationForm):
    class Meta:
        model = User
        fields = ['username', 'email', 'password1', 'password2']
        help_texts = {"username": None,
                      "email": None,
                      "password2": None
                      }

    @transaction.atomic
    def save(self):
        user = super().save(commit=False)
        user.is_admin = True
        user.is_client = False
        user.is_staff = True
        user.save()
        return user


class ImageUploadForm(forms.Form):
    """Image upload form."""
    image = forms.ImageField()

Movie/movie_admin/forms.py
from django import forms
from recommendation.models import Movie


class AddMoviesForm(forms.ModelForm):
    class Meta:
        model = Movie
        fields = ('title', 'genre', 'poster', 'imdbrating', 'year')

Movie/movie_admin/views.py
from django.http import HttpResponse
from django.shortcuts import render, redirect
from django.contrib.auth.decorators import login_required
from login_signup.decorators import admin_required, client_required
from login_signup.models import User
from recommendation.models import Client, Movie
from .forms import AddMoviesForm
import sweetify
import csv

# Create your views here.
@login_required
@admin_required
def adminhome(request):
    count = Client.objects.filter(user=request.user).count()
    movie_count = Movie.objects.all().count()
    user_count = User.objects.all().count()
    admin_count = User.objects.filter(is_admin=1).count()
    context = {'count': count, 'movie_count': movie_count, 'user_count': user_count, 'admin_count': admin_count}
    return render(request, 'movie_admin/adminhome.html', context)


@login_required
@admin_required
def adminpanel(request):
    users = User.objects.all()  # .objects le chai whole table ko records lai nai as object return garxa
    clients = Client.objects.all()
    context = {'users': users, 'clients': clients}
    return render(request, 'movie_admin/adminpanel.html', context)


@login_required
@admin_required
def rating_details(request, id):  # url request ma id pani aauxa as parameter to this edit function
    users = User.objects.get(
        id=id)  # id(primary key) ko help batw table ma vayeko pariticular user ko record set nikaleko
    clients = Client.objects.filter(
        user=id)  # Note :  FOREIGN KEY CONCEPT   # .Filter le table ma vayeko selective  records set lai retun gari rako hunxa  # parameter batw aayeko id lai, Client table ko user vanni foreigh key wala field(column)  ma assign garya ho because particular  id ko jati record tyo client ma cha sabbai chaiyeko vayera
    counts = Client.objects.filter(user=id).count()
    context = {'clients': clients, 'users': users, 'counts': counts}
    # print(counts)
    return render(request, 'movie_admin/rating_details.html', context)


@login_required
@admin_required
def delete(request, id):  # url request ma id pani aauxa as parameter to this delete function.
    users = User.objects.get(id=id)
    users.delete()
    return redirect('adminpanel')


@login_required
@admin_required
def listMovies(request):
    all_movies = Movie.objects.all()
    context = {'all_movies': all_movies}
    return render(request, 'movie_admin/list_movies.html', context)


@login_required
@admin_required
def addMovies(request):

    if request.method == 'POST':
        print(request)
        form = AddMoviesForm(request.POST, request.FILES)
        print(form)
        if form.is_valid():
            try:
                form.save()
                sweetify.success(request, 'Movie added successfully!',
                                 text='Good job! You have successfully added Movie.',
                                 persistent='ok', icon='success')
            except Exception as e:
                sweetify.error(request, 'Something Went Wrong', text=str(e), persistent='Close', icon='error')
                return redirect('add_movies')

    form = AddMoviesForm()
    return render(request, 'movie_admin/add_movies.html', {'form': form})


@login_required
@admin_required
def deleteMovies(request, movie_id):
    if request.method == 'POST':
        delete_movie = Movie.objects.get(pk=movie_id)
        delete_movie.delete()
        sweetify.success(request, 'Movie deleted successfully!',
                         text='Good job! You have successfully deleted Movie.',
                         persistent='ok', icon='success')
        return redirect('list_movies')


def editMovies(request, movie_id):
    if request.method == 'POST':
        edit_record = Movie.objects.get(pk=movie_id)
        form = AddMoviesForm(request.POST or None, request.FILES or None, instance=edit_record)  # request.FILES is needed for updating the image field as well and while saving form we need to do this => edit = form.save(commit=False) and then only edit.save()
        if form.is_valid:
            edit = form.save(commit=False)
            edit.save()
            sweetify.success(request, 'Movie edited successfully!',
                             text='Good job! You have successfully edited Movie.',
                             persistent='ok', icon='success')

        return redirect('list_movies')
    else:
        edit_record = Movie.objects.get(pk=movie_id)
        form = AddMoviesForm(instance=edit_record)

    return render(request, 'movie_admin/edit_movies.html', {'form': form})



def dwonloadCSV(request):
    response = HttpResponse(content_type='text/csv')
    response['Content-Disposition'] = 'attachment; filename="ratings.csv"'
    writer = csv.writer(response)

    writer.writerow(['userId', 'movieId', 'rating'])
    clients = Client.objects.all().values_list('user', 'movie', 'rating')
    for client in clients:
        writer.writerow(client)
    return response

Movie/movie_admin/templates/movie_admin/add_movies.html
{% extends 'movie_admin/admin_base.html' %}
{% load static %}
{% load crispy_forms_tags %}
{% block body %}

    <div class="breadcrumbs">
        <div class="col-sm-4">
            <div class="page-header float-left">
                <div class="page-title">
                    <h1>Dashboard</h1>
                </div>
            </div>
        </div>
        <div class="col-sm-8">
            <div class="page-header float-right">
                <div class="page-title">
                    <ol class="breadcrumb text-right">
                        <li><a href="{% url 'adminhome' %}">Dashboard</a></li>
                        <li class="active">Add Movie</li>
                    </ol>
                </div>
            </div>
        </div>
    </div>


    <div class="content mt-3">
        <div class="animated fadeIn">
            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <strong class="card-title mb-3">Add Movie</strong>
                            <span class="float-right">
                                <a href="{% url 'list_movies' %}" class="btn btn-info">List Movies</a>
                            </span>
                        </div>
                        <div class="card-body">
                            <form action="{% url 'add_movies' %}" method="POST" enctype="multipart/form-data">
                                {% csrf_token %}
                                <div class="form-group">
                                    <i class="fa fa-film" aria-hidden="true"></i>
                                    <label for="title">Movie Title:</label><br>
                                    <input type="text" name="title" id="id_title" class="form-control" required>
                                </div>
                                <div class="form-group">
                                    <i class="fa fa-list-alt" aria-hidden="true"></i>
                                    <label for="genre">Genre:</label><br>

{#                                    <input type="text" name="genre" id="id_genre" class="form-control" required>#}

{#                                    <select name="genre" id="id_genre" class="form-control" required>#}
{#                                        <option value="Action">Action</option>#}
{#                                        <option value="Animation">Saab</option>#}
{#                                        <option value="mercedes">Mercedes</option>#}
{#                                        <option value="audi">Audi</option>#}
{#                                    </select>#}
                                     {{ form.genre|as_crispy_field  }}


                                </div>
                                <div class="form-group">
                                    <i class="fa fa-star" aria-hidden="true" style="color: gold"></i>

                                    <label for="imdbrating">IMDB Rating:</label><br>
                                    <input type="number" name="imdbrating" id="id_imdbrating" class="form-control"
                                           step="any"
                                           required>
                                </div>
                                <div class="form-group">
                                    <i class="fa fa-calendar" aria-hidden="true"></i>
                                    <label for="year">Year:</label><br>

{#                                    <input type="text" name="year" id="id_year" class="form-control" required>#}
                                     {{ form.year|as_crispy_field  }}
                                </div>


                                <div class="form-group">
                                    <i class="fa fa-picture-o" aria-hidden="true"></i>
                                    <label for="poster">Choose Poster:</label><br>
                                    <input type="file" name="poster" id="id_poster" class="form-control" required>
                                </div>


                                <div class="modal-footer">
                                    <button type="submit" class="btn btn-success">Add</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

Movie/movie_admin/templates/movie_admin/adminhome.html
{% extends 'movie_admin/admin_base.html' %}
{% load static %}
{% load crispy_forms_tags %}

{% block body %}

    <div class="breadcrumbs">
        <div class="col-sm-4">
            <div class="page-header float-left">
                <div class="page-title">
                    <h1>Dashboard</h1>
                </div>
            </div>
        </div>
        <div class="col-sm-8">
            <div class="page-header float-right">
                <div class="page-title">
                    <ol class="breadcrumb text-right">
                        <li class="active">Dashboard</li>
                    </ol>
                </div>
            </div>
        </div>
    </div>

    <div class="content mt-3">

        <div class="col-sm-12">
            <div class="alert  alert-success alert-dismissible fade show" role="alert">
                <span class="badge badge-pill badge-success">Welcome!</span> to our admin dashboard.
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
        </div>


        <div class="col-sm-6 col-lg-3">
            <div class="card text-white bg-flat-color-1">
                <div class="card-body pb-0">
                    <div class="dropdown float-right">
                        <button class="btn bg-transparent dropdown-toggle theme-toggle text-light" type="button"
                                id="dropdownMenuButton1" data-toggle="dropdown">
                            <i class="fa fa-cog"></i>
                        </button>
                        <div class="dropdown-menu" aria-labelledby="dropdownMenuButton1">
                            <div class="dropdown-menu-content">
                                <a class="dropdown-item" href="#">Action</a>
                                <a class="dropdown-item" href="#">Another action</a>
                                <a class="dropdown-item" href="#">Something else here</a>
                            </div>
                        </div>
                    </div>
                    <h4 class="mb-0">
                        <span class="count">{{ movie_count }}</span>
                    </h4>
                    <p class="text-light"><i class="fa fa-film"></i> Total Movies</p>

                    <div class="chart-wrapper px-0" style="height:70px;" height="70">
                        <canvas id="widgetChart1"></canvas>
                    </div>

                </div>

            </div>
        </div>
        <!--/.col-->

        <div class="col-sm-6 col-lg-3">
            <div class="card text-white bg-flat-color-2">
                <div class="card-body pb-0">
                    <div class="dropdown float-right">
                        <button class="btn bg-transparent dropdown-toggle theme-toggle text-light" type="button"
                                id="dropdownMenuButton2" data-toggle="dropdown">
                            <i class="fa fa-cog"></i>
                        </button>
                        <div class="dropdown-menu" aria-labelledby="dropdownMenuButton2">
                            <div class="dropdown-menu-content">
                                <a class="dropdown-item" href="#">Action</a>
                                <a class="dropdown-item" href="#">Another action</a>
                                <a class="dropdown-item" href="#">Something else here</a>
                            </div>
                        </div>
                    </div>
                    <h4 class="mb-0">
                        <span class="count">{{ user_count }}</span>
                    </h4>
                    <p class="text-light"><i class="fa fa-user-circle"></i> User's Count</p>

                    <div class="chart-wrapper px-0" style="height:70px;" height="70">
                        <canvas id="widgetChart2"></canvas>
                    </div>

                </div>
            </div>
        </div>
        <!--/.col-->

        <div class="col-sm-6 col-lg-3">
            <div class="card text-white bg-flat-color-3">
                <div class="card-body pb-0">
                    <div class="dropdown float-right">
                        <button class="btn bg-transparent dropdown-toggle theme-toggle text-light" type="button"
                                id="dropdownMenuButton3" data-toggle="dropdown">
                            <i class="fa fa-cog"></i>
                        </button>
                        <div class="dropdown-menu" aria-labelledby="dropdownMenuButton3">
                            <div class="dropdown-menu-content">
                                <a class="dropdown-item" href="#">Action</a>
                                <a class="dropdown-item" href="#">Another action</a>
                                <a class="dropdown-item" href="#">Something else here</a>
                            </div>
                        </div>
                    </div>
                    <h4 class="mb-0">
                        <span class="count">{{ admin_count }}</span>
                    </h4>
                    <p class="text-light"><i class="fa fa-user-md"></i> Admin's Count</p>

                </div>

                <div class="chart-wrapper px-0" style="height:70px;" height="70">
                    <canvas id="widgetChart3"></canvas>
                </div>
            </div>
        </div>
        <!--/.col-->


        <div class="col-sm-6 col-lg-2 offset-1">

            <a href="{% url 'download_csv' %}" id="download_csv">
            <button class="btn " style="background-color: #272c33; color: white"><i class="fa fa-download"></i> Export Rating CSV</button>
            </a>

        </div>
        <!--/.col-->


        <!--/.col-->
    </div> <!-- .content -->

    <!-- User Profile Card -->
    <div class="content mt-3">
        <div class="animated fadeIn">
            <div class="row">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <strong class="card-title mb-3">Profile Detail</strong>
                        </div>
                        <div class="card-body">
                            <div class="mx-auto d-block">
                                <img class="rounded-circle mx-auto d-block" src="{{ user.image.url }}" width="150;"
                                     height="150;"
                                     style="margin-top: 50px; border: 2px solid black; padding: 10px;"
                                     alt="Card image cap">

                                <h5 class="text-sm-center mt-2 mb-1">{{ request.user }}</h5>
                                <form action="{% url 'upload_pic' %}" method="post" enctype="multipart/form-data">
                                    {% csrf_token %}
                                    <div class="text-sm-center mt-2 mb-1" style="margin-left: 18%">
                                        <input id="id_image" type="file" name="image">

                                    </div>
                                    <div class="text-sm-center mt-2 mb-1">
                                        <input type="submit" value="Submit" class="btn btn-success">
                                    </div>
                                </form>

                            </div>

                            <table class="table table-hover mt-4 text-center">
                                <tbody>
                                <tr>
                                    <td>Username:</td>
                                    <td>{{ request.user }}</td>
                                </tr>
                                <tr>
                                    <td>Email:</td>
                                    <td>{{ request.user.email }}</td>
                                </tr>
                                <tr>
                                    {% if request.user.is_client %}
                                        <td> User Type:</td>
                                        <td> User</td>
                                    {% else %}
                                        <td> User Type:</td>
                                        <td> Admin</td>
                                    {% endif %}
                                </tr>

                                <tr>
                                    <td>User ID :</td>
                                    <td>{{ request.user.id }}</td>
                                </tr>
                                <tr>
                                    <td>Joined Date:</td>
                                    <td>{{ request.user.date_joined }}</td>
                                </tr>

                                <tr>
                                    <td>Last Seen:</td>
                                    <td>{{ request.user.last_login }}</td>
                                </tr>

                                <tr>
                                    <td>Movie Rated:</td>
                                    <td>{{ count }}</td>
                                </tr>


                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

Movie/movie_admin/templates/movie_admin/adminpanel.html
{% extends 'movie_admin/admin_base.html' %}
{% load static %}


{% block body %}
    {% block style %}
        <style>
            .dataTables_filter, .pagination {
                float: right;
            }


        </style>
    {% endblock %}
    <div class="breadcrumbs">
        <div class="col-sm-4">
            <div class="page-header float-left">
                <div class="page-title">
                    <h1>Dashboard</h1>
                </div>
            </div>
        </div>
        <div class="col-sm-8">
            <div class="page-header float-right">
                <div class="page-title">
                    <ol class="breadcrumb text-right">
                        <li><a href="{% url 'adminhome' %}">Dashboard</a></li>
                        <li><a href="{% url 'adminpanel' %}">User</a></li>
                        <li class="active">View User's Detail</li>
                    </ol>
                </div>
            </div>
        </div>
    </div>

    <div class="content mt-3">
        <div class="animated fadeIn">
            <div class="row">

                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <strong class="card-title">User's Detail</strong>
                            <span class="float-right">
                                <a href="{% url 'adminregister' %}" class="btn btn-dark">Add Admin</a>
                            </span>
                        </div>
                        <div class="card-body">
                            <table id="bootstrap-data-table-export" class="table  table-bordered table-hover">
                                <thead>
                                <tr>
                                    <th>Username</th>
                                    <th>Email</th>
                                    <th>Is_admin</th>
                                    <th>Is_client</th>
                                    <th>Action</th>

                                </tr>
                                </thead>
                                <tbody>
                                {% for user in users %}
                                    <tr>
                                        <td>{{ user.username }}</td>
                                        <td>{{ user.email }}</td>
                                        {% if user.is_admin == True %}
                                            <td class="text-center">
                                                <img src="{% static 'images/user_active.png' %}" alt="True" width="50">
                                            </td>
                                        {% else %}
                                            <td class="text-center">
                                                <img src="{% static 'images/user_deactive.png' %}" alt="False"
                                                     width="50">
                                            </td>
                                        {% endif %}

                                        {% if user.is_client == True %}
                                            <td class="text-center">
                                                <img src="{% static 'images/user_active.png' %}" alt="True" width="50">
                                            </td>
                                        {% else %}
                                            <td class="text-center">
                                                <img src="{% static 'images/user_deactive.png' %}" alt="False"
                                                     width="50">
                                            </td>
                                        {% endif %}
                                        <td>
                                            <a href="{% url 'rating_details' user.id %}"><span
                                                    class="btn btn-success">View Details</span></a>

                                        </td>
                                    </tr>
                                {% endfor %}

                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>


            </div>
        </div><!-- .animated -->
    </div><!-- .content -->
{% endblock %}